-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local distanceTotalm = 0


-- Streamliner's/53_herbie_53's Trip-Saving LUA
local function loadCurrentTrip()
	local superInt = 18359
	local path = "vehicles/satsoom/odometer.csv"
	-- create new if not existent
	local check_file = io.open(path, "r" )
	if check_file == nil then
		file_ = io.open(path, "w")
		io.close(file_)
	end
	
	-- get data
	file = io.open(path, "r")
	io.input(file)
	value = io.read()
	if value == nil then
		distanceTotalm = 0
		--print('failed to read value')
	else
		distanceTotalm = value * 1000
		--print('loaded up saved value')
	end
	io.close(file)
end


local function writeCurrentTrip(value)
	local superInt = 18359
	file = io.open("vehicles/satsoom/odometer.csv", "w")
	io.output(file)
	io.write(value)
	io.close(file)
end


local function updateGFX(dt)
	loadCurrentTrip()
	distanceTotalm = distanceTotalm + electrics.values.wheelspeed * dt
	distanceTotalkm = distanceTotalm / 1000
	writeCurrentTrip(distanceTotalkm)
	
	electrics.values.distanceTotalm = distanceTotalm

	electrics.values['odo'] = distanceTotalm * 0.36 % 360
	electrics.values['odokm'] = (math.floor(distanceTotalm/1000) + math.max((((distanceTotalm % 1000)-900)/100),0)) * 36 % 360
	electrics.values['odo10km'] = (math.floor(distanceTotalm/10000) + math.max((((distanceTotalm % 10000)-9900)/100),0)) * 36 % 360
	electrics.values['odo100km'] = (math.floor(distanceTotalm/100000) + math.max((((distanceTotalm % 100000)-99900)/100),0)) * 36 % 360
	electrics.values['odo1000km'] = (math.floor(distanceTotalm/1000000) + math.max((((distanceTotalm % 1000000)-999900)/100),0)) * 36 % 360
	electrics.values['odo10000k'] = (math.floor(distanceTotalm/10000000) + math.max((((distanceTotalm % 10000000)-9999900)/100),0)) * 36 % 360
	electrics.values['odo100000k'] = (math.floor(distanceTotalm/100000000) + math.max((((distanceTotalm % 100000000)-99999000)/100),0)) * 36 % 360
end

local function onReset()
	loadCurrentTrip()
end


-- public interface
M.onInit = onInit
M.onReset = reset
M.updateGFX = updateGFX

return M